=== debian/changelog ===
ectrans (1.6.2-3) unstable; urgency=medium

  * Rebuild for gcc-15

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 11 Sep 2025 14:08:36 +0100

ectrans (1.6.2-2) unstable; urgency=medium

  * Push to unstable

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 14 Aug 2025 09:39:05 +0100

ectrans (1.6.2-1) experimental; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 25 Jul 2025 12:34:03 +0100

ectrans (1.6.1-1) experimental; urgency=medium

  * New upstream release, Closes: #1104358

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 23 May 2025 09:26:27 +0100

ectrans (1.6.0-4) experimental; urgency=medium

  * Build-Depend on gfortran
  * Build-dep on libfckit-dev >=0.13.4-2 for eckit fix. Closes: #1104358

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 07 May 2025 18:02:53 +0100

ectrans (1.6.0-3) experimental; urgency=medium

  * Don't FTBFSif ectrans-lam* not created (riscv64, etc)

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 16 Apr 2025 08:25:06 +0100

ectrans (1.6.0-2) unstable; urgency=medium

  * OpenMP needed for etrans; disable for riscv64 etc

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 14 Apr 2025 09:52:34 +0100

ectrans (1.6.0-1) unstable; urgency=medium

  * New upstream release
  * Standards-Version: 4.7.2
  * Enable ETRANS for Limited-Area models

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 11 Apr 2025 12:17:40 +0100
